--# main_program;
procedure ProdMain
--#  derives;
is
   procedure Prod(X,Z: in Natural; P : out Natural)
   --# derives P from X,
   --#                Z;
   --# pre X*Z<= Natural'Last;
   --# post P = X*Z;
   is
     Y: Natural;
   begin
     P:=0; Y:=0;
     loop
     --# assert P=X*Y and 0<=Y and Y<=Z;
       exit when Y=Z;
       P:=P+X; Y:=Y+1;
     end loop;
   end Prod;

   procedure Call(F1,F2: in Natural; R : out Natural)
   --# derives R from F1,
   --#                F2;
   is
      interface : Integer;
   begin
      R:=0;
      if F2 = 0 or else F1 <= Natural'Last / F2
      then
         Prod(F1,F2,R);
      end if;
   end Call;

begin
   null;
end ProdMain;
